<?php
//Some txtSQL settings
$build='0.3a';
$sqlPath    = 'txtsql/';
define('TXTSQL_CORE_PATH', $sqlPath);
$sqlData    = DATA_PATH.'/sql';
$sqlUser    = 'root';
$sqlPass    = '';
$sqlDB      = 'rcms_forum';
require_once($sqlPath . 'txtSQL.class.php');
$sql = new txtSQL($sqlData);
// some forum settings 
$easy_navigation='true';
$display_forum_stats='true';
$search_enabled="true";

//////////////////////////// API

//Just connect to database
function txtsql_connect() {
global $sql;
global $sqlPath;
global $sqlData;
global $sqlUser;
global $sqlPass;
global $sqlDB;
$sql->strict(0);
$sql->connect($sqlUser, $sqlPass) or showError($LANG['txtsql']['connectError'], E_USER_ERROR, $sql->get_last_error());
$sql->selectdb($sqlDB);
}
//function to mark topic as closed
function mark_topic_closed($id) {
global $sql;
txtsql_connect();
$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'where'  => array('id = '.$id),
		'values' => array('closed' => '1')
		));
show_window(__('Result'),__('Topic and all replys marked as closed'));	
}

//get login from username
function get_user_login($username) {
$userdata=getUserData($username);	
return ($userdata['nickname']);
}

//function checks topic for closed status
function topic_closed($id) {
global $sql;
txtsql_connect();
$topicclosed=false;
$query=$sql->execute('select',
           array('select' => array('id','closed'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 'where'  => array('id = '.mysql_escape_string($id)),
                 ));
foreach ($query as $key=>$row) {
	if($row['closed']==1) {
		$topicclosed=true;
	}
}
                 
 return ($topicclosed);
	
}

//function to mark topic as open
function mark_topic_open($id) {
global $sql;
txtsql_connect();
$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'where'  => array('id = '.$id),
		'values' => array('closed' => '0')
		));
show_window(__('Result'),__('Topic and all replys marked as open'));	
}

// Function that shows available categories
function show_cats() {
global $sql;
txtsql_connect();
$result='<table border="0" width="100%">';
$query=
   $sql->execute('select',
           array('select' => array('id', 'name','pos'),
                 'db'     => 'rcms_forum',
                 'table'  => 'categories',
                 'orderby' => array('pos', 'ASC')));

   foreach ( $query as $key => $row )
   {
     $result.='<tr><td style="text-align: center; width: 100%; height: 32px" class="frrow2">'.$row['name'].'</td></tr>'."\n";
     $result.='<tr><td>';
     $result.=show_subcats($row['id']);
     $result.='</td></tr>';
   }
$result.='</table>';
return ($result);
}

//function that shows subcats in target category
function show_subcats($id) {
global $sql;
txtsql_connect();
$result='';
$query=
   $sql->execute('select',
           array('select' => array('id','subid' ,'name'),
                 'db'     => 'rcms_forum',
                 'table'  => 'subcats',
                 'where'  => array('subid = '.mysql_escape_string($id))
                 ));

   foreach ( $query as $key => $row )
   {
     $result.='<table width="100%">
     <tr><td width="10%" class="frrow1"><img src="skins/forum/folder_big.gif"></td><td class="frrow1" width="80%"><a href="?module=justforum&subcat='.$row['id'].'">'.$row['name'].'</a></td><td width="10%" class="frrow2">'.topics_count($row['id']).'</td></tr>
     </table>
     '."\n";
   }
return ($result);
}

//function that shows topics in target subcategory
function show_topics($id) {
global $sql,$easy_navigation;
txtsql_connect();
$result='<p align="right"><a href="?module=justforum&action=createtopic&subcat='.$id.'"><img src="skins/forum/post.gif"></a></p>
<table border="0" width="100%">
<tr>
<td class="frrow3" width="5%"></td>
    <td class="frrow3" width="65%">'.__('Title').'</a></td>
     <td class="frrow3" width="10%">'.__('Author').'</a></td>
     <td class="frrow3" width="10%">'.__('Posts').'</td>
     <td class="frrow3" width="10%">'.__('Date').'</td>
     </tr>';
$query=
   $sql->execute('select',
           array('select' => array('id','subcat','author','date','title','closed','sticky','hidden','replies'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 'where'  => array('subcat = '.mysql_escape_string($id), 'and', 'hidden = 0'),
                 'orderby' => array('date', 'DESC')
                 ));

   foreach ( $query as $key => $row )
   {
   	if ($row['closed']==0) {
   		$topicicon='<img src="skins/forum/folder.gif">';
   	}
   	else {
   		$topicicon='<img src="skins/forum/folder_lock.gif">';
   	}
   		if ($easy_navigation=='false') {
     $result.='
     <tr><td class="frrow1" width="5%">'.$topicicon.'</td><td class="frrow1" width="65%">
     <a href="?module=justforum&showtopic='.$row['id'].'">'.$row['title'].'</a></td>
     <td class="frrow1" width="10%"><a href="?module=user.list&user='.$row['author'].'">'.get_user_login($row['author']).'</a></td>
     <td class="frrow1" width="10%">'.replies_count($row['id']).'</td>
     <td class="frrow1" width="10%">'.rcms_format_time('H:i d.m.Y',$row['date']).'</td>
     </tr>'."\n";
   	}
   	else {
   	$result.='<tr><td class="frrow1" width="5%">'.$topicicon.'</td><td class="frrow1" width="65%">
     <a href="?module=justforum&ttm='.translit_string($row['title']).'">'.$row['title'].'</a></td>
     <td class="frrow2" width="10%"><a href="?module=user.list&user='.$row['author'].'">'.get_user_login($row['author']).'</a></td>
     <td class="frrow3" width="10%">'.replies_count($row['id']).'</td>
     <td class="frrow2" width="10%">'.rcms_format_time('H:i d.m.Y',$row['date']).'</td>
     </tr>'."\n";	
   	}
   }

$result.='</table>';
return ($result);
}

//function that shows returns topic id by translited title
function get_topic_id_by_title($str) {
global $sql;
txtsql_connect();
$ident=0;
$query=
   $sql->execute('select',
           array('select' => array('id','title'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 ));
foreach ($query as $key => $row) {
if(translit_string($row['title'])==$str) {
$ident=$row['id'];
	}
}
return ($ident);
}



//function that shows selected topic
function show_topic($id) {
global $sql;
txtsql_connect();
$result='';
$query=
   $sql->execute('select',
           array('select' => array('id','subcat','author','date','title','closed','sticky','hidden','replies','text'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 'where'  => array('id = '.mysql_escape_string($id))
                 ));

   foreach ( $query as $key => $row )
   {
     $result.='
     <p align ="right"><a href="?module=justforum&subcat='.$row['subcat'].'"><-'.__('Back to topics list').'</a></p>
 <table style="text-align: left; width: 100%;" border="0" cellpadding="2" cellspacing="2" class="border">
  <tbody>
    <tr>
      <td colspan="2" rowspan="1" class="window-title">'.$row['title'].'</td>
    </tr>
    <tr class="frrow1">
      <td width="20%">'.rcms_format_time('H:i:s d.m.Y',$row['date']).'</td>
      <td align="right">
      <a href="?module=pm&for='.$row['author'].'"><img src="skins/forum/icon_pm.gif"></a>
      <a href="?module=user.list&user='.$row['author'].'"><img src="skins/forum/icon_profile.gif"></a>
      <img src="skins/forum/icon_edit.gif">'
      . (cfm() ? ' <a href="?module=justforum&action=viewips&author='.$row['author'].'"><img src="skins/forum/icon_ip.gif"></a> ' : '')
      . (cfm() ? '<a href="?module=justforum&action=closetopic&topic='.$row['id'].'"> <img src="skins/forum/topic_lock.gif"></a> ' : '')  
      . (cfm() ? ' <a href="?module=justforum&action=hidetopic&topic='.$row['id'].'"><img src="skins/forum/icon_delete.gif"></a> ' : '') . '
      </td>
    </tr>
    <tr>
      <td width="20%" class="frrow1">
      <p align="center"><b><a href="?module=user.list&user='.$row['author'].'">'.get_user_login($row['author']).'</a></b></p>
	  <p align="center">
      '.show_avatar($row['author']).'<br>   
      '.get_user_posts_count($row['author']).'</p>
      </td>
      <td width="80%" valign="top" class="frrow1">'.rcms_parse_text(stripcslashes($row['text'])).'</td>
    </tr>
    <tr>
      <td colspan="2" rowspan="1" align="right">
         <a href="?module=justforum&action=createreply&topic='.$row['id'].'"><img src="skins/forum/reply.gif"></a>
      </td>
    </tr>
  </tbody>
</table>
<div>'.get_rate($_GET['module'].$id).'</div>'
     ;
   }

return ($result);
}

//function that shows replies for selected topic
function show_replies($id) {
global $sql;
txtsql_connect();
$result='';
$query=
   $sql->execute('select',
           array('select' => array('id','repto','author','date','text','hidden'),
                 'db'     => 'rcms_forum',
                 'table'  => 'replies',
                 'where'  => array('repto = '.mysql_escape_string($id))
                 ));

   foreach ( $query as $key => $row )
   {
   	if($row['hidden']!=1) {
     $result.=' 
 <table style="text-align: left; width: 100%;" border="0" cellpadding="2" cellspacing="2" >
  <tbody>
    <tr class="frrow1">
      <td colspan="2" rowspan="1"></td>
    </tr>
    <tr>
      <td width="20%" class="frrow1">'.rcms_format_time('H:i:s d.m.Y',$row['date']).'</td>
      <td align="right" class="frrow1">
      <a href="?module=pm&for='.$row['author'].'"><img src="skins/forum/icon_pm.gif"></a>
      <a href="?module=user.list&user='.$row['author'].'"><img src="skins/forum/icon_profile.gif"></a>
       <img src="skins/forum/icon_edit.gif">'
       . (cfm() ? ' <a href="?module=justforum&action=viewips&author='.$row['author'].'"><img src="skins/forum/icon_ip.gif"></a> ' : '')
       . (cfm() ? ' <a href="?module=justforum&action=hidereply&reply='.$row['id'].'"><img src="skins/forum/icon_delete.gif"></a>' : '').'
      </td>
    </tr>
    <tr>
      <td width="20%" class="frrow1">
   <p align="center"><b><a href="?module=user.list&user='.$row['author'].'">'.get_user_login($row['author']).'</a></b></p>
	  <p align="center">
      '.show_avatar($row['author']).'<br>   
      '.get_user_posts_count($row['author']).'</p>

      </td>
      <td width="80%" valign="top" class="frrow1">'.rcms_parse_text(stripcslashes($row['text'])).'</td>
    </tr>
    <tr>
      <td colspan="2" rowspan="1" align="right">
      <a href="?module=justforum&action=createreply&topic='.$row['repto'].'"><img src="skins/forum/reply.gif"></a>  
      </td>
    </tr>
  </tbody>
</table>
     ';
   }}
return ($result);	
}

//function that creates new topic with data in params
function create_topic($subcat, $author, $date, $title, $text) {
global $sql;
txtsql_connect();
$query=
   $sql->execute('insert', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'values' => array(
		'subcat' => mysql_escape_string($subcat),
		'author' => mysql_escape_string($author),
		'date' => mysql_escape_string($date),
		'title' => mysql_escape_string($title),
		'text' => mysql_escape_string($text),
		'closed' => 0,
		'sticky' => 0,
		'hidden' => 0,
		'replies' => 0
		)));
	
}
//function shows forum head
function forum_header() {
	global $search_enabled;
	$head='
	<img src="skins/forum/icon_mini_faq.gif"><a href="?module=justforum&admcore=init">'.__('Administration').'</a> 
	<img src="skins/forum/icon_mini_register.gif"> <a href="?module=user.profile&act=register">'.__('Registration').'</a>
	<img src="skins/forum/icon_mini_profile.gif"> <a href="?module=user.profile">'.__('Profile').'</a>
	<img src="skins/forum/icon_mini_members.gif"><a href="?module=user.list">'.__('Member list').'</a>
	<img src="skins/forum/icon_mini_message.gif"> <a href="?module=pm&mode=get">'.__('Messages ').'</a>
	<hr>
	
	<form action="?module=justforum&action=search" method="POST">
	<img src="skins/forum/icon_mini_search.gif"> 
	<input type="text" name="tofind">
	<input type="submit" value="'.__('Search').'">
	</form><br>
	';
	show_window(__('Forum'),$head,'right');
}


//Function that returns topics counter in subcat
function topics_count($id) {
global $sql;
txtsql_connect();
$topics_counter=0;
$query=
   $sql->execute('select',
           array('select' => array('id','subcat'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 'where'  => array('subcat = '.mysql_escape_string($id), 'and','hidden = 0')
                 ));
                 
foreach ( $query as $key => $row ) {
	$topics_counter++;
}
return ($topics_counter);
}

//Function that returns replies counter in topic
function replies_count($id) {
global $sql;
txtsql_connect();
$replies_counter=0;
$query=
   $sql->execute('select',
           array('select' => array('id','repto','hidden'),
                 'db'     => 'rcms_forum',
                 'table'  => 'replies',
                 'where'  => array('repto = '.mysql_escape_string($id), 'and','hidden = 0')
                 ));
                 
foreach ( $query as $key => $row ) {
	$replies_counter++;
}
return ($replies_counter);
}

//function that creates new replie for topic with data in params
function create_replie($repto, $author, $date, $text) {
global $sql;
txtsql_connect();
$query=
   $sql->execute('insert', array(
		'db'     => 'rcms_forum',
		'table'  => 'replies',
		'values' => array(
		'repto' => mysql_escape_string($repto),
		'author' => mysql_escape_string($author),
		'date' => mysql_escape_string($date),
		'text' => mysql_escape_string($text), 
		'hidden' => 0
		)));
add_user_post($author);
}

//Showing reply creation form for target topic
function show_reply_create_form($id) {
	$form='
	<table width="100%" border="0">
	<tr><td align="center" class="border">
	<p align="center">
	<form method="POST" action="" name="postforumreply">
	'.rcms_show_bbcode_panel('postforumreply.messagetext').
	'<input type="hidden" name="repto" value="'.$id.'" />
	<input type="hidden" name="postreply" value="true">
	' . __('Message text') . ': <br>
	<textarea name="messagetext" width="90%" cols="60" rows="7"></textarea>
	<p align="center"><input type="submit" value="' . __('Submit') . '" /></p>
	</form>
	</p>
	</td></tr>
	<tr>
	<td class="border">
	'.show_replies($id).'
	</td>
	</tr>
	</table>
	';
	
show_window('',$form);
	
}

//Showing reply creation form for target topic
function show_topic_create_form($id) {
	$form='
	<table width="100%" border="0">
	<tr><td align="center" class="border">
	<p align="center">
	<form method="POST" action="" name="postforumtopic">
	'.rcms_show_bbcode_panel('postforumtopic.messagetext').
	'<input type="hidden" name="subcat" value="'.$id.'" />
	<input type="hidden" name="posttopic" value="true">
	'.__('Title').'
	<input type="text" name="topictitle" size="30"><br>
	' . __('Message text') . ': <br>
	<textarea name="messagetext" width="90%" cols="60" rows="7"></textarea>
	<p align="center"><input type="submit" value="' . __('Submit') . '" /></p>
	</form>
	</p>
	</td></tr>
	<tr>
	<td class="border">
	'.show_replies($id).'
	</td>
	</tr>
	</table>
	';
	
show_window('',$form);
	
}




//Funtion to transform text to translit
function translit_string($var) {
	    $NpjLettersFrom = " ";
        $NpjLettersTo   = "abvgdeziklmnoprstufcyiie_";
        $NpjBiLetters = array(
      "" => "jj", "" => "jo", "" => "zh", "" => "kh", "" => "ch",
      "" => "sh", "" => "shh", "" => "je", "" => "ju", "" => "ja",
      "" => "", "" => "");

        $NpjCaps  = "Ũ߲ ";
        $NpjSmall = " ";

        $var = trim(strip_tags($var));
          $var = preg_replace( "/s+/ms", "_", $var );
          $var = strtr( $var, $NpjCaps, $NpjSmall );
         $var = strtr( $var, $NpjLettersFrom, $NpjLettersTo );
         $var = strtr( $var, $NpjBiLetters );
        $var = preg_replace("/[^a-z0-9_]+/mi", "", $var);
        $var = strtolower ( $var );
        return ($var); 
}

//adds users post to authors table
function add_user_post($user) {
global $sql;
txtsql_connect();
$query=
   $sql->execute('insert', array(
		'db'     => 'rcms_forum',
		'table'  => 'authors',
		'values' => array(
		'author' => $user,
		'ip' => $_SERVER['REMOTE_ADDR'],
		'posts' => '1'
		)));

}

//function return array of ips for selected user
function show_author_ips($user) {
global $sql;
txtsql_connect();
$query=
   $sql->execute('select',
           array('select' => array('ip', 'author'),
                 'db'     => 'rcms_forum',
                 'table'  => 'authors',
                 'where'  => array('author = '.$user),
                 'distinct' => 'ip'
                 ));
return ($query);
}

//check ip ban status
function check_ban_status($ip) {
	if (!$banlist = @file(CONFIG_PATH . 'bans.ini')) $banlist = array();
	return in_array($ip, $banlist);
}

//ban selected ip
function ban_ip() {
	if(!$banlist = @file(CONFIG_PATH . 'bans.ini')) $banlist = array();
	$banlist[] = $_GET['id'];
	file_write_contents(CONFIG_PATH . 'bans.ini', @implode("\n", @$banlist));
}

//unban selected ip
function unban_ip() {
	if(!$banlist = @file(CONFIG_PATH . 'bans.ini')) $banlist = array();
	$banlist_new = array();
	foreach ($banlist as $ban)
		if ($ban != $_GET['id'])
			$banlist_new[] = $ban;
	file_write_contents(CONFIG_PATH . 'bans.ini', @implode("\n", @$banlist_new));
}

//function shows ips for all users
function show_all_ips() {
global $sql;
txtsql_connect();
$query1=
   $sql->execute('select',
           array('select' => array('author'),
                 'db'     => 'rcms_forum',
                 'table'  => 'authors',
                 'distinct' => 'author'
                 ));


$result='<table width="100%">';
if (sizeof($query1) > 0)
	$result .= '<tr class="frrow3"><td width=20%>'.__('Author').'</td><td>'.__('Known IP').'</td></tr>';
foreach ($query1 as $value=>$row) {
$result.='<tr><td>'.$row['author'].'</td>';
$result.='<td>';
foreach (show_author_ips($row['author']) as $key => $row) {
	$result.='<a href = "http://'.$row['ip'].'" target="_blank">'.$row['ip'].'</a>';
	if (check_ban_status($row['ip'])) {
		$result.='(<a href = "?module=justforum&admcore=userips&faction=unban&id='.$row['ip'].'"><b>'.__('Unban').'</b></a>),&nbsp;';
	} else
		$result.='(<a href = "?module=justforum&admcore=userips&faction=ban&id='.$row['ip'].'">'.__('Ban').'</a>),&nbsp;';
}
$result .='</td></tr>';
}
$result.='<tr align=midle><td colspan=2><hr></td></tr><tr align=right><td colspan=2>'.__('Also').' <a href="admin.php?show=module&id=users.bans">'.__('Manage banlist').'</a>&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>';

return ($result);
}

//function that mark reply as hidden for further cleanup
function mark_replie_hidden($id) {
global $sql;
txtsql_connect();
$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'replies',
		'where'  => array('id = '.$id),
		'values' => array('hidden' => '1')
		));
show_window(__('Result'),__('Reply marked as hidden'));		
}

//function to return current time
function get_current_time() {
return (rcms_get_time());
}

//function that mark topic as hidden for further cleanup
function mark_topic_hidden($id) {
global $sql;
txtsql_connect();
$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'where'  => array('id = '.$id),
		'values' => array('hidden' => '1')
		));
$query2=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'replies',
		'where'  => array('repto = '.$id),
		'values' => array('hidden' => '1')
		));
show_window(__('Result'),__('Topic and all replys marked as hidden'));	
}

//function to flush items in trash box 
function flush_trash_box() {
global $sql;
txtsql_connect();
$query=$sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'where'  => array('hidden = 1'),
		));	
		
$query2=$sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => 'replies',
		'where'  => array('hidden = 1'),
		));			
}

//function to restore items from trash box 
function restore_trash_box() {
global $sql;
txtsql_connect();
$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'replies',
		'where'  => array('hidden = 1'),
		'values' => array('hidden' => '0')
		));
$query2=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'where'  => array('hidden = 1'),
		'values' => array('hidden' => '0')
		));
}

// Displays trash box with hidden items
function trash_box() {
	global $sql;
	txtsql_connect();
	$result='<table width="100%">';
	$query=$sql->execute('select',
           array('select' => array('text', 'id','hidden','author','date'),
                 'db'     => 'rcms_forum',
                 'table'  => 'replies',
                 'where'  => array('hidden = 1')
                 ));
    $query2=$sql->execute('select',
           array('select' => array('text', 'id','hidden','author','date'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 'where'  => array('hidden = 1')
                 ));
           
     if (sizeof($query) > 0) 
       $result .= '<tr class="frrow3"><td colspan=4 align=middle>'.__('Deleted replies').'</td></tr><tr class="frrow3"><td>'.__('Author').'</td><td>'.__('Date').'</td><td>'.__('Text').'</td><td>'.__('Actions').'</td></tr>';
     foreach ($query as $key => $row) {
     $result.='<tr class="frrow1">
     <td width="10%">
      '.$row['author'].'
     </td>
     <td width="20%">
      '.rcms_format_time('H:i:s d.m.Y',$row['date']).'
     </td>
     <td width="60%">
     '.$row['text'].'
     </td>
     <td width="10%">
     <a href = "?module='.$_GET['module'].'&admcore=showtrashbox&ftype=replies&fdel='.$row['id'].'"><img src="skins/forum/delete.gif" alt="'.__('Delete').'"></a>
     <a href = "?module='.$_GET['module'].'&admcore=showtrashbox&ftype=replies&fres='.$row['id'].'"><img src="skins/forum/restore.gif" alt="'.__('Restore').'"></a>
     </td>
     </tr>
     ';
     }
     
     if (sizeof($query2) > 0) 
       $result .= '<tr class="frrow3"><td colspan=4 align=middle>'.__('Deleted topics').'</td></tr> <tr class="frrow3"><td>'.__('Author').'</td><td>'.__('Date').'</td><td>'.__('Text').'</td><td>'.__('Actions').'</td></tr>';
     foreach ($query2 as $key => $row) {
     $result.='<tr class="frrow1">
     <td width="10%">
      '.$row['author'].'
     </td>
     <td width="20%">
      '.rcms_format_time('H:i:s d.m.Y',$row['date']).'
     </td>
     <td width="60%">
     '.$row['text'].'
     </td>
     <td width="10%">
     <a href = "?module='.$_GET['module'].'&admcore=showtrashbox&ftype=topics&fdel='.$row['id'].'"><img src="skins/forum/delete.gif" alt="'.__('Delete').'"></a>
     <a href = "?module='.$_GET['module'].'&admcore=showtrashbox&ftype=topics&fres='.$row['id'].'"><img src="skins/forum/restore.gif" alt="'.__('Restore').'"></a>
     </td>
     </tr>
     ';
     }
     if (sizeof($query2) <= 0 AND sizeof($query) <= 0) { 
     	$result .= '<tr><td align=middle>'.__('No hidden topics and replies').'</td></tr>';
    } else {
    	$result.='<tr><td colspan=4 align=middle><hr></td></tr><tr><td colspan=4 align=right>'.__('Also').' <a href="?module='.$_GET['module'].'&admcore=showtrashbox&faction=emptytrashbox">'.__('Delete all').'</a> '.__('or').' '; 
    	$result.='&nbsp;<a href="?module='.$_GET['module'].'&admcore=showtrashbox&faction=restoretrashbox">'.__('Restore all').'</a>&nbsp;&nbsp;&nbsp;&nbsp;</td></tr>'; 
    }

     $result.='</table>';
     
     return ($result);
}

//delete or restore curent item from trash
function del_res_from_trash() {
	global $sql;
	txtsql_connect();
	if (isset($_GET['fdel']))
		$query=$sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => $_GET['ftype'],
		'where'  => array('id = '.$_GET['fdel']),
		));	
	if (isset($_GET['fres']))
		$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => $_GET['ftype'],
		'where'  => array('id = '.$_GET['fres']),
		'values' => array('hidden' => '0')
		));	
}

//just shows admin core interface
function show_admin_core() {
	$form='
	<table width="100%">
	<tr align="center">
	<td width="25%"><a href="?module=justforum&admcore=cats"><img src="skins/forum/admcore/addsubcat.gif"><br>'.__('Manage categories').'</a></td>
	<td width="25%"><a href="?module=justforum&admcore=subcats"><img src="skins/forum/admcore/edit.gif"><br>'.__('Manage subcategories').'</a></td>
	<td width="25%"><a href="?module=justforum&admcore=userips"><img src="skins/forum/admcore/users.gif"><br>'.__('User IPs').'</a></td>
	<td width="25%"><a href="?module=justforum&admcore=showtrashbox"><img src="skins/forum/admcore/trashcan_full-alt.gif"><br>'.__('Trash box').'</a></td>
	</table>
	';
	show_window(__('Administration'),$form);
	$_GET['hideforum'] = 1;
}

// shows forum stats
function show_forum_data() {
global $sql,$build;
txtsql_connect();	
$topiccount = $sql->table_count('topics', 'rcms_forum');
$repliescount=$sql->table_count('replies', 'rcms_forum');
$qc=$sql->query_count();
$result='<img src="skins/forum/whosonline.gif"> '.__('Now forum contains ').$topiccount.__(' topics and ').$repliescount.__(' replies').', '.$qc.__(' SQL queries executed').' build:'.$build;
show_window(__('Forum stats'),$result);
}


// function to check moderator rights 
function cfm() {
global $system;
if ($system->checkForRight('FORUM',$system->user['username'])) {
	return (true);
	}
	else {
	return (false);
	}
}

//function that returns user posts
function get_user_posts_count($user) {
global $sql;
txtsql_connect();
$topicz=$sql->execute('select',
           array('select' => array('author'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                 'where'  => array('author = '.$user)
                 ));

$repliez=$sql->execute('select',
           array('select' => array('author'),
                 'db'     => 'rcms_forum',
                 'table'  => 'replies',
                 'where'  => array('author = '.$user)
                 ));
$user_posts=sizeof($repliez)+sizeof($topicz);
return ($user_posts);
}


//function searches some text in messages
function forum_search($str) {
global $sql;
txtsql_connect();
$result='<table width="100%" border="0">';
$ts=$sql->execute('select',
           array('select' => array('text','id','title'),
                 'db'     => 'rcms_forum',
                 'table'  => 'topics',
                   ));	
                 
  foreach ($ts as $key => $row) {
  	$insearch=trim($row['text'],"\r");
  	if (eregi(trim($str),$insearch)) {
  	$result.='<tr><td class="row2"><a href="?module=justforum&showtopic='.$row['id'].'">'.$row['title'].'</a></td></tr>';
  	}
  }
  $result.='</table>';
  return ($result);
}

// add new category
function add_category (){
	global $sql;
	txtsql_connect();
	$pos = '1';
	$query2 = $sql->execute('select',
           array('select' => array('pos'),
           'db'     => 'rcms_forum',
           'table'  => 'categories',
           'orderby' => array('pos', 'DESC')));
    if (sizeof($query2) > 0)
    	$pos = ($query2[0]['pos']+1);
	if (trim($_GET['name']) !== '')
	$query=	$sql->execute('insert', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'values' => array(
		'name' => mysql_escape_string($_GET['name']),'pos' => $pos)));
}

// show delete category warning
function show_delete_category_warning (){
	show_window( __('Warning!'),'<p align = center fontsize = +2>'.__('All subcategories, topics and replies will deleted forever !!!').'<br><br>
	<a href="?module=justforum&admcore=cats&faction=delete2&id='.$_GET['id'].'">'.__('Yes, delete').'</a>&nbsp;&nbsp;&nbsp;&nbsp;
	<a href="?module=justforum&admcore=cats">'.__('No, return').'</a></p>');
}

// delete category with subcontents
function delete_category (){
	global $sql;
	txtsql_connect();
	$query=$sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'where'  => array('id = '.$_GET['id'])));
	$query2 = $sql->execute('select',
           array('select' => array('id','subid'),
           'db'     => 'rcms_forum',
           'table'  => 'subcats',
           'where'  => array('subid = '.$_GET['id'])));
    foreach ($query2 as $key => $val) {
    	$query3=$sql->execute('select',
        	array('select' => array('id','subcat'),
        	'db'     => 'rcms_forum',
            'table'  => 'topics',
            'where'  => array('subcat = '.$key)));
        foreach ($query3 as $key2 => $val2) {
    		$query4 = $sql->execute('delete', array(
				'db'     => 'rcms_forum',
				'table'  => 'replies',
				'where'  => array('repto = '.$key2)));
		}
		$query5 = $sql->execute('delete', array(
			'db'     => 'rcms_forum',
			'table'  => 'topics',
			'where'  => array('subcat = '.$key)));
    }
    $query5 = $sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('subid = '.$_GET['id'])));
     
}

// rename category
function rename_category (){
	global $sql;
	txtsql_connect();
	if (trim($_GET['newname']) !== '')
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'where'  => array('id = '.$_GET['id']),
		'values' => array('name' => $_GET['newname'])
		));
}

// move category up
function move_category_up () {
	global $sql;
	txtsql_connect();
	$query2 = $sql->execute('update',
        array('db' => 'rcms_forum',
        'table'  => 'categories',
        'where'  => array('pos = '.($_GET['id']-1)),
        'values' => array('pos' => '0')
        ));
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'where'  => array('pos = '.$_GET['id']),
		'values' => array('pos' => ($_GET['id']-1))
		));
	$query3=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'where'  => array('pos = 0'),
		'values' => array('pos' => $_GET['id'])
		));
}

// move category down
function move_category_down () {
	global $sql;
	txtsql_connect();
	$query2 = $sql->execute('update',
        array('db' => 'rcms_forum',
        'table'  => 'categories',
        'where'  => array('pos = '.($_GET['id']+1)),
        'values' => array('pos' => '0')
        ));
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'where'  => array('pos = '.$_GET['id']),
		'values' => array('pos' => ($_GET['id']+1))
		));
	$query3=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'where'  => array('pos = 0'),
		'values' => array('pos' => $_GET['id'])
		));
}

// manage categories
function manage_categories() {
	global $sql;
	txtsql_connect();
	$ts=$sql->execute('select',
		array('select' => array('id','name', 'pos'),
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'orderby' => array('pos', 'ASC')
	));
	$result='<table width="100%" border="0">';
	if (sizeof($ts) > 0)
		$result.='<tr class="frrow3"><td width=30%>'.__('Old name').'</td><td width=50%>'.__('New name').'</td><td width=20%>'.__('Actions').'</td></tr>';	
	$i=0;
	foreach ($ts as $key => $row) {
		$result.='<tr><td>'.$row['name'].'</td><td><form method="get">
		<input type = "hidden" name="module" value="justforum">
		<input type = "hidden" name="admcore" value="cats">
		<input type = "hidden" name="faction" value="rename">
		<input type = "hidden" name="id" value="'.$row['id'].'">
		<input type = "text" name="newname" value="'.$row['name'].'" size=40>
		<input type = "submit" value="'.__('Submit').'"></form>
		</td>
		<td><a href="?module=justforum&admcore=cats&faction=delete&stop=yes&id='.$row['id'].'">'.__('Delete').'</a>';
		if ($i !== 0) {
			$result.='&nbsp;&nbsp;<a href="?module=justforum&admcore=cats&faction=up&id='.$row['pos'].'">'.__('Up').'</a>';
		} else {
			$result.='&nbsp;&nbsp;<strike>'.__('Up').'</strike>';
		}
		if ($i !== (sizeof($ts)-1)) {
			$result.='&nbsp;&nbsp;<a href="?module=justforum&admcore=cats&faction=down&id='.$row['pos'].'">'.__('Down').'</a>';
		} else {
			$result.='&nbsp;&nbsp;<strike>'.__('Down').'</strike>';
		}
		$result.='</td></tr>';
		$i++;
	}
	$result.='<tr><td colspan=3 aligh="middle"><hr></tr><tr><td>'.__('Add new category').'</td><td><form method="get">
		<input type = "hidden" name="module" value="justforum">
		<input type = "hidden" name="admcore" value="cats">
		<input type = "hidden" name="faction" value="add">
		<input type = "text" name="name" value="" size=40>
		<input type = "submit" value="'.__('Submit').'"></form></td><td></td></tr>';	
	$result.='</table>';
	return ($result);
}

// add new subcategory
function add_subcategory (){
	global $sql;
	txtsql_connect();
	$pos = '1';
	$query2 = $sql->execute('select',
           array('select' => array('pos'),
           'db'     => 'rcms_forum',
           'table'  => 'subcats',
           'where' => array('subid = '.$_GET['subid']),
           'orderby' => array('pos', 'DESC')));
    if (sizeof($query2) > 0)
    	$pos = ($query2[0]['pos']+1);
	if (trim($_GET['name']) !== '')
	$query=	$sql->execute('insert', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'values' => array(
		'name' => mysql_escape_string($_GET['name']),'pos' => $pos, 'subid' => $_GET['subid'])));
}

// show delete subcategory warning
function show_delete_subcategory_warning (){
	show_window( __('Warning!'),'<p align = center fontsize = +2>'.__('All topics and replies will deleted forever !!!').'<br><br>
	<a href="?module=justforum&admcore=subcats&faction=delete2&subid='.$_GET['subid'].'&id='.$_GET['id'].'">'.__('Yes, delete').'</a>&nbsp;&nbsp;&nbsp;&nbsp;
	<a href="?module=justforum&admcore=subcats">'.__('No, return').'</a></p>');
}

// delete subcategory with subcontents
function delete_subcategory (){
	global $sql;
	txtsql_connect();
    $query3=$sql->execute('select',
    	array('select' => array('id','subcat'),
    	'db'     => 'rcms_forum',
    	'table'  => 'topics',
    	'where'  => array('subcat = '.$_GET['id'])));
    foreach ($query3 as $key2 => $val2) {
    	$query4 = $sql->execute('delete', array(
			'db'     => 'rcms_forum',
			'table'  => 'replies',
			'where'  => array('repto = '.$key2)));
	}
	$query5 = $sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => 'topics',
		'where'  => array('subcat = '.$_GET['subid'])));
    $query5 = $sql->execute('delete', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('id = '.$_GET['id'])));
}

// rename subcategory
function rename_subcategory (){
	global $sql;
	txtsql_connect();
	if (trim($_GET['newname']) !== '')
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('id = '.$_GET['id']),
		'values' => array('name' => $_GET['newname'])
		));
}

// move subcategory into another category
function move_subcategory_into (){
	global $sql;
	txtsql_connect();
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('id = '.$_GET['id']),
		'values' => array('subid' => $_GET['subid'])
		));
}

// move subcategory up
function move_subcategory_up () {
	global $sql;
	txtsql_connect();
	$query2 = $sql->execute('update',
        array('db' => 'rcms_forum',
        'table'  => 'subcats',
        'where'  => array('pos = '.($_GET['id']-1), 'AND', 'subid = '.$_GET['subid']),
        'values' => array('pos' => '0')
        ));
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('pos = '.$_GET['id'], 'AND', 'subid = '.$_GET['subid']),
		'values' => array('pos' => ($_GET['id']-1))
		));
	$query3=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('pos = 0', 'AND', 'subid = '.$_GET['subid']),
		'values' => array('pos' => $_GET['id'])
		));
}

// move subcategory down
function move_subcategory_down () {
	global $sql;
	txtsql_connect();
	$query2 = $sql->execute('update',
        array('db' => 'rcms_forum',
        'table'  => 'subcats',
        'where'  => array('pos = '.($_GET['id']+1), 'AND', 'subid = '.$_GET['subid']),
        'values' => array('pos' => '0')
        ));
	$query=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('pos = '.$_GET['id'], 'AND', 'subid = '.$_GET['subid']),
		'values' => array('pos' => ($_GET['id']+1))
		));
	$query3=$sql->execute('update', array(
		'db'     => 'rcms_forum',
		'table'  => 'subcats',
		'where'  => array('pos = 0', 'AND', 'subid = '.$_GET['subid']),
		'values' => array('pos' => $_GET['id'])
		));
}

// manage subcategories
function manage_subcategories() {
	global $sql;
	txtsql_connect();
	$ts=$sql->execute('select',
		array('select' => array('id','name', 'pos'),
		'db'     => 'rcms_forum',
		'table'  => 'categories',
		'orderby' => array('pos', 'ASC')
	));
	$cat_html_list = '<select name="subid">';
	foreach ($ts as $k => $v)
		$cat_html_list.='<option value="'.$v['id'].'">'.$v['name'].'</option>';
	$cat_html_list.='</select>';
	$result='<table width="100%" border="0">';
	foreach ($ts as $key => $row) {
		$result.='<tr class="frrow3"><td colspan=4 align=center>'.__('Category').': <b>'.$row['name'].'</b></td></tr>';	
		if (sizeof($ts) > 0)
			$result.='<tr class="frrow3"><td width=20%>'.__('Old name').'</td><td width=30%>'.__('New name').'</td><td width=30%>'.__('New plae').'</td><td width=20%>'.__('Actions').'</td></tr>';	
		$i=0;
		$ts2=$sql->execute('select',
			array('select' => array('id','name', 'pos'),
			'db'     => 'rcms_forum',
			'table'  => 'subcats',
			'where'  => array('subid = '.$row['id']),
			'orderby' => array('pos', 'ASC')
		));
		foreach ($ts2 as $key2 => $row2) {
			$result.='<tr><td>'.$row2['name'].'</td><td><form method="get">
			<input type = "hidden" name="module" value="justforum">
			<input type = "hidden" name="admcore" value="subcats">
			<input type = "hidden" name="faction" value="rename">
			<input type = "hidden" name="id" value="'.$row2['id'].'">
			<input type = "text" name="newname" value="'.$row2['name'].'" size=20>
			<input type = "submit" value="'.__('Submit').'"></form></td>';
			$result.='<td><form method="get">
			<input type = "hidden" name="module" value="justforum">
			<input type = "hidden" name="admcore" value="subcats">
			<input type = "hidden" name="faction" value="move">
			<input type = "hidden" name="id" value="'.$row2['id'].'">
			'.$cat_html_list.'
			<input type = "submit" value="'.__('Submit').'"></form>
			</td>
			<td><a href="?module=justforum&admcore=subcats&faction=delete&stop=yes&subid='.$row['id'].'&id='.$row2['id'].'">'.__('Delete').'</a>';
			if ($i !== 0) {
				$result.='&nbsp;&nbsp;<a href="?module=justforum&admcore=subcats&faction=up&subid='.$row['id'].'&id='.$row2['pos'].'">'.__('Up').'</a>';
			} else {
				$result.='&nbsp;&nbsp;<strike>'.__('Up').'</strike>';
			}
			if ($i !== (sizeof($ts2)-1)) {
				$result.='&nbsp;&nbsp;<a href="?module=justforum&admcore=subcats&faction=down&subid='.$row['id'].'&id='.$row2['pos'].'">'.__('Down').'</a>';
			} else {
				$result.='&nbsp;&nbsp;<strike>'.__('Down').'</strike>';
			}
			$result.='</td></tr>';
			$i++;
		}
		$result.='<tr><td>'.__('Add new subcategory').'</td><td><form method="get">
			<input type = "hidden" name="module" value="justforum">
			<input type = "hidden" name="admcore" value="subcats">
			<input type = "hidden" name="faction" value="add">
			<input type = "hidden" name="subid" value="'.$row['id'].'">
			<input type = "text" name="name" value="" size=20>
			<input type = "submit" value="'.__('Submit').'"></form></td><td></td></tr>
			<tr><td colspan=3 aligh="middle">&nbsp;</tr>';	
	}
	$result.='</table>';
	return ($result);
}

////////////////////////////////////////////////////////// Main code part ///////////////////////////////////////////////////////
forum_header();
//Posting reply into topic
if ((isset($_POST['repto'])) AND (isset($_POST['postreply'])) AND (isset($_POST['messagetext']))){
	if ((!empty($_POST['repto'])) AND (!empty($_POST['postreply'])) AND (!empty($_POST['messagetext']))){
	create_replie($_POST['repto'],$system->user['username'],get_current_time(),$_POST['messagetext']);
   }
}
//posting topic
if ((isset($_POST['subcat'])) AND (isset($_POST['posttopic'])) AND (isset($_POST['messagetext'])) AND(isset($_POST['topictitle']))){
if ((!empty($_POST['subcat'])) AND (!empty($_POST['posttopic'])) AND (!empty($_POST['messagetext'])) AND (!empty($_POST['topictitle']))){
	create_topic($_POST['subcat'],$system->user['username'],get_current_time(),$_POST['topictitle'],$_POST['messagetext']);
   }
}

if (isset($_GET['admcore'])) {
	if(cfm()) {
		show_admin_core();
		if ($_GET['admcore']=='showtrashbox') {
			if (isset($_GET['faction'])) {
				if ($_GET['faction']=='emptytrashbox') 
					flush_trash_box();
				if ($_GET['faction']=='restoretrashbox') 
					restore_trash_box();
			}
			if ( isset($_GET['fdel']) OR isset($_GET['fres']))
				del_res_from_trash();
			show_window(__('Trash box'),trash_box());
		}
		if ($_GET['admcore']=='userips') {
			if (isset($_GET['faction'])) {
				if ($_GET['faction']=='ban') 
					ban_ip();
				if ($_GET['faction']=='unban') 
					unban_ip();
			}	
			show_window('',show_all_ips());
		}
		if ($_GET['admcore']=='cats') {
			if (isset($_GET['faction'])) {
				if ($_GET['faction']=='delete') 
					show_delete_category_warning();
				if ($_GET['faction']=='delete2') 
					delete_category();
				if ($_GET['faction']=='rename') 
					rename_category();
				if ($_GET['faction']=='add') 
					add_category();
				if ($_GET['faction']=='up') 
					move_category_up();
				if ($_GET['faction']=='down') 
					move_category_down();
			}	
			if (!isset($_GET['stop']))
				show_window('',manage_categories());
		}
		if ($_GET['admcore']=='subcats') {
			if (isset($_GET['faction'])) {
				if ($_GET['faction']=='delete') 
					show_delete_subcategory_warning();
				if ($_GET['faction']=='delete2') 
					delete_subcategory();
				if ($_GET['faction']=='rename') 
					rename_subcategory();
				if ($_GET['faction']=='add') 
					add_subcategory();
				if ($_GET['faction']=='up') 
					move_subcategory_up();
				if ($_GET['faction']=='down') 
					move_subcategory_down();
				if ($_GET['faction']=='move') 
					move_subcategory_into();
			}	
			if (!isset($_GET['stop']))
				show_window('',manage_subcategories());
		}
	} else {
 		show_error(__('You have not permissions'));
 	}
 }

if (isset($_GET['showtopic']) OR isset($_GET['ttm'])) 
{
	if (!empty($_GET['ttm'])) {
	show_window('',show_topic(get_topic_id_by_title($_GET['ttm'])));
	show_window(__('Replies'),show_replies(get_topic_id_by_title($_GET['ttm']))); 
		
	} 
		else 
	{
		show_window('',show_topic($_GET['showtopic']));
		show_window(__('Replies'),show_replies($_GET['showtopic'])); 
	}
	
} else {
	if ((!isset($_GET['subcat'])) AND (!isset($_GET['action'])) AND (!isset($_GET['hideforum']))) {
    show_window('',show_cats());
}
else {
	if((!isset($_GET['action'])) AND (!isset($_GET['hideforum']))) {
	show_window(__('Topics list'),show_topics($_GET['subcat']));
	}
}


if(isset($_GET['action'])) {
	if($_GET['action']=='createreply') {
		if (LOGGED_IN) {
		if (isset($_GET['topic'])) {
		show_reply_create_form($_GET['topic']);		
		}} else { show_error(__('Only for registered users')); }
	}
if($_GET['action']=='createtopic') { 
    if (isset($_GET['subcat'])) {
    	if (LOGGED_IN) {
    show_topic_create_form($_GET['subcat']);	
    } else { show_error(__('Only for registered users')); }
   }}



if($_GET['action']=='viewips') { 
	   if (isset($_GET['author'])) {
	   	if (cfm()) {
	   		$allipz=show_author_ips($_GET['author']);
	   		$ipzz='';
	   		foreach ($allipz as $key) {
	   		$ipzz.=$key['ip'].'<br>';
	   		}
   	      show_window(__('IP adress'),$ipzz);
	   	} else { show_error(__('You have not permissions ')); }
    }
   }
   

if($_GET['action']=='closetopic') { 
    if (isset($_GET['topic'])) {
    		if (cfm()) {
    			if (topic_closed($_GET['topic'])) {
   	mark_topic_open($_GET['topic']); } else {
   	mark_topic_closed($_GET['topic']);	
   	}
   	
     } else { show_error(__('You have not permissions ')); }
    }
   }
   
if($_GET['action']=='hidereply') { 
    if (isset($_GET['reply'])) {
    		if (cfm()) {
   	mark_replie_hidden($_GET['reply']);
     } else { show_error(__('You have not permissions ')); }
    }
   }
   
if($_GET['action']=='hidetopic') { 
    if (isset($_GET['topic'])) {
    		if (cfm()) {
   	mark_topic_hidden($_GET['topic']);
    		} else { show_error(__('You have not permissions ')); }
    }
   } 

if($_GET['action']=='search') { 
	if((isset($_POST['tofind'])) AND ($search_enabled=='true')) {
show_window(__('Search'),forum_search($_POST['tofind']));
	}
}
}

}

if ($display_forum_stats=='true') {
show_forum_data();	
}

?>